/*
 * Copyright (c) 1991-2023 by STEP Tools Inc. 
 * All Rights Reserved.
 * 
 * Permission to use, copy, modify, and distribute this software and
 * its documentation is hereby granted, provided that this copyright
 * notice and license appear on all copies of the software.
 * 
 * STEP TOOLS MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE
 * SUITABILITY OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, OR NON-INFRINGEMENT. STEP TOOLS
 * SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A
 * RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
 * DERIVATIVES.
 *
 * Author: David Loffredo (loffredo@steptools.com)
 */


// CREATE A SWEPT POLYGON SHELL WITH HOLES - pass in a list of 2D
// points and a thickness.  Use those points to define a polygonal
// face in the XY plane, define another one offset by thickness in the
// -Z direction, then sew everything up as a closed brep shell.
//
// Pass back the shell.  Pass back the top and bottom face in case we
// want to define any holes in them.
//

stp_cartesian_point * make_point(
    RoseDesign * d,
    double x, double y, double z = 0
    );

void make_polygon_shell (
    stp_closed_shell ** ret_shell, 
    stp_advanced_face ** ret_top, 
    stp_advanced_face ** ret_bottom, 
    RoseDesign * d,
    ListOfstp_cartesian_point * xypts, 
    double thickness
    );


void make_circular_hole (
    stp_closed_shell * shell, 
    stp_advanced_face * top_face, 
    stp_advanced_face * bottom_face, 
    double x, double y,
    double radius,
    double thickness
    );


void make_polygon_hole (
    stp_closed_shell * shell, 
    stp_advanced_face * top_face, 
    stp_advanced_face * bottom_face, 
    ListOfstp_cartesian_point * xypts,
    double thickness
    );

